#ifndef EFL_SCREEN_EO_HH
#define EFL_SCREEN_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_screen.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
namespace efl { 
struct Screen;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Screen> : ::std::true_type {}; } }

namespace eo_cxx {
namespace efl { 
struct Screen {
   ::efl::eolian::return_traits<void>::type screen_size_get( ::efl::eolian::out_traits<int>::type w,  ::efl::eolian::out_traits<int>::type h) const;
   ::efl::eolian::return_traits<int>::type screen_rotation_get() const;
   ::efl::eolian::return_traits<void>::type screen_dpi_get( ::efl::eolian::out_traits<int>::type xdpi,  ::efl::eolian::out_traits<int>::type ydpi) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_SCREEN_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::Screen() const;
   operator ::efl::Screen&();
   operator ::efl::Screen const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Screen> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Screen const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace efl { 
struct Screen : ::efl::eo::concrete
{
   explicit Screen( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Screen(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Screen(Screen const& other) = default;
   Screen(Screen&& other) = default;
   Screen& operator=(Screen const& other) = default;
   Screen& operator=(Screen&& other) = default;
   Screen()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Screen( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Screen(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<void>::type screen_size_get( ::efl::eolian::out_traits<int>::type w,  ::efl::eolian::out_traits<int>::type h) const;
   ::efl::eolian::return_traits<int>::type screen_rotation_get() const;
   ::efl::eolian::return_traits<void>::type screen_dpi_get( ::efl::eolian::out_traits<int>::type xdpi,  ::efl::eolian::out_traits<int>::type ydpi) const;
   static Eo_Class const* _eo_class()
   {
      return EFL_SCREEN_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Screen> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Screen const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Screen) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Screen>::value, "");
} 
#include "efl_screen.eo.impl.hh"
#endif
